<template>
  <no-ssr>
    <div class="volume-chart">
      <Icon v-if="lockP5Drawing" class="p5-lock" type="md-lock" />
      <nuxt-p5 :id="domId"
               :width="width"
               :height="height"
               @size="sizeAction" v-on="script">
      </nuxt-p5>
    </div>
  </no-ssr>
</template>

<script>
  import NuxtP5 from './NuxtP5';
  import { script, actions, emits, events, functions, baseConfig } from '../../helpers/p5';

  const p5Events = {
    ...events,
    _draw(sketch) {
      if (!this.lockP5Drawing) {
        this.sketch = sketch;
        this.drawBackground(sketch);
        this.drawCoordinateSystem(sketch);
        this.drawDataPointBar(sketch);
        this.drawCrossHair(sketch);
      }
    },
  };

  const p5Functions = {
    ...functions,
    drawDataPointBar(sketch) {
      const leftBottom = this.canvas.coordinate.leftBottom;
      this.canvas.show.points.forEach((point) => {
        const data = this.data[point.key];

        // opening price - closing price
        let rectHeight = leftBottom.y - point.y['volume'];
        sketch.fill(data['candleStickColor']);
        sketch.noStroke();
        sketch.rect(point.x - this.canvas.xUnit/2, point.y['volume'], this.canvas.xUnit, rectHeight);
      });
    },
  };

  export default {
    name: "StockVolumeChart",
    mixins: [baseConfig],
    components: {NuxtP5},
    props: {},
    data() {
      return {
        domId: `volume-chart-${(new Date()).getTime().toString()}`,
        script: script(this),
        canvas: {
          coordinate: {
            step: 1,
            longMarkStep: 10,
            shortMarkStep: 5,
            leftTextBound: 55,
          },
          crossHair: { fractionDigits: 0 },
        },
        dataFields: [
          { dataField: 'volume', label: 'Vol', color: '#ff6666' },
        ],
        fieldToShow: ['volume'],
      };
    },
    computed: {},
    watch: {},
    methods: {
      ...actions,
      ...emits,
      ...p5Events,
      ...p5Functions,
    },
    mounted() {},
  }
</script>

<style scoped>

</style>
